MessageTest PROGRAM

OMIT('*NOTES*')
 Demonstrates how to replace the standard MESSAGE function and
 provides a fair equivalent of MESSAGE.

 I wrote this because, I wanted to be able to control the font of
 the message window.  Perhaps there is a better way?

 Author: Steve Lewis, Aphelion Software, slewis@aphelioninc.com
         09/16/98

 This code can be freely copied, altered, posted, etc.
 Consume at your own risk, and have fun!

 Thanks to Frank Piscopo for ideas and logic that came from a similar
 example he posted.
*NOTES*

  INCLUDE('KEYCODES.CLW')

  MAP
    Main
    MyMessage(STRING,<STRING>,<STRING>,<STRING>,UNSIGNED=0,BOOL=FALSE),UNSIGNED,PROC
  END

  CODE
  Main()

Main PROCEDURE

UseHook             BYTE(1)
MsgStr              STRING(300)
IconChoice          BYTE(1)
IconVal             STRING(100)
IsModal             BYTE
Caption             STRING(30),AUTO

UseOK               BYTE
UseYes              BYTE
UseNo               BYTE
UseAbort            BYTE
UseRetry            BYTE
UseIgnore           BYTE
UseCancel           BYTE
UseHelp             BYTE

DefaultButtonChoice BYTE
DefaultButton       LONG,AUTO
Buttons             LONG,AUTO
ReturnVal           LONG

window WINDOW('Message Test'),AT(,,311,193),SYSTEM
       CHECK('Use my message'),AT(9,9),USE(UseHook)
       ENTRY(@s30),AT(38,29,108,10),USE(Caption)
       BUTTON('Display Message'),AT(154,5,151,19),USE(?DisplayMessage)
       TEXT,AT(7,44,139,128),USE(MsgStr)
       CHECK('Modal'),AT(7,176),USE(IsModal)
       STRING('Return value ='),AT(54,176),USE(?String1)
       STRING(@n-6),AT(107,176),USE(ReturnVal),LEFT
       GROUP('Buttons'),AT(155,88,72,98),USE(?ButtonGroup),BOXED
         CHECK('OK'),AT(168,98),USE(UseOK)
         CHECK('Yes'),AT(168,108),USE(UseYes)
         CHECK('No'),AT(168,118),USE(UseNo)
         CHECK('Abort'),AT(168,128),USE(UseAbort)
         CHECK('Retry'),AT(168,138),USE(UseRetry)
         CHECK('Ignore'),AT(168,148),USE(UseIgnore)
         CHECK('Cancel'),AT(168,158),USE(UseCancel)
         CHECK('Help'),AT(168,168),USE(UseHelp)
       END
       OPTION('Default Button'),AT(233,88,72,98),USE(DefaultButtonChoice),BOXED
         RADIO('OK'),AT(247,98),USE(?DefaultButtonChoice:OK)
         RADIO('Yes'),AT(247,108),USE(?DefaultButtonChoice:Yes)
         RADIO('No'),AT(247,118),USE(?DefaultButtonChoice:No)
         RADIO('Abort'),AT(247,128),USE(?DefaultButtonChoice:Abort)
         RADIO('Retry'),AT(247,138),USE(?DefaultButtonChoice:Retry)
         RADIO('Ignore'),AT(247,148),USE(?DefaultButtonChoice:Ignore)
         RADIO('Cancel'),AT(247,158),USE(?DefaultButtonChoice:Cancel)
         RADIO('Help'),AT(247,168),USE(?DefaultButtonChoice:Help)
       END
       OPTION('Icon'),AT(154,26,151,56),USE(IconChoice),BOXED
         RADIO('None'),AT(163,39),USE(?IconChoice:None)
         RADIO('Question'),AT(163,54),USE(?IconChoice:Question)
         RADIO('Exclamation'),AT(163,69),USE(?IconChoice:Exclamation)
       END
       PROMPT('Caption:'),AT(7,29),USE(?Prompt1)
     END

  CODE
  Caption = 'Caption'

  OPEN(Window)
  ACCEPT
    CASE ACCEPTED()
    OF ?DisplayMessage
      EXECUTE IconChoice
        IconVal = ''
        IconVal = ICON:Question
        IconVal = ICON:Exclamation
      END
      IF UseHook
        SYSTEM{PROP:MessageHook} = ADDRESS(MyMessage)
      ELSE
        SYSTEM{PROP:MessageHook} = 0
      END

      Buttons = 0
      IF UseOK     THEN Buttons += BUTTON:OK.
      IF UseYes    THEN Buttons += BUTTON:YES.
      IF UseNo     THEN Buttons += BUTTON:NO.
      IF UseAbort  THEN Buttons += BUTTON:ABORT.
      IF UseRetry  THEN Buttons += BUTTON:RETRY.
      IF UseIgnore THEN Buttons += BUTTON:IGNORE.
      IF UseCancel THEN Buttons += BUTTON:CANCEL.
      IF UseHelp   THEN Buttons += BUTTON:HELP.

      EXECUTE DefaultButtonChoice
        DefaultButton = BUTTON:OK
        DefaultButton = BUTTON:YES
        DefaultButton = BUTTON:NO
        DefaultButton = BUTTON:ABORT
        DefaultButton = BUTTON:RETRY
        DefaultButton = BUTTON:IGNORE
        DefaultButton = BUTTON:CANCEL
        DefaultButton = BUTTON:HELP
      ELSE
        DefaultButton = 0
      END

      ReturnVal = MESSAGE(MsgStr, Caption, IconVal, Buttons, DefaultButton, IsModal)
      DISPLAY(?ReturnVal)
    END
  END
  CLOSE(Window)


MyMessage FUNCTION(MessageText, Caption, DisplayIcon, Buttons, DefaultButton, Style)

_ButtonHeight    EQUATE(14)
_ButtonWidth     EQUATE(38)
_ButtonOffset    EQUATE(6)
_IconSize        EQUATE(14)

St               STRING(600),AUTO
Lines            STRING(60),DIM(8)
LineCount        BYTE,AUTO
CPos1            LONG(1)
CPos2            LONG,AUTO
Width1           LONG,AUTO
Width2           LONG
StrHeight        LONG,AUTO
IconOffset       BYTE,AUTO

ControlNo        LONG
TotalStrings     LONG,AUTO
TotalButtons     LONG,AUTO
ButtonCount      LONG,AUTO
ButtonsVal       LONG,AUTO
ButtonType       LONG,AUTO
ButtonX          LONG,AUTO
ButtonResults    LONG,DIM(8)
Result           LONG

MsgWin WINDOW('Caption'),AT(,,100,20),FONT('Arial',12,,FONT:bold)
     END

  CODE
  OPEN(MsgWin)

  LOOP
    CPos2 = INSTRING('<10>', MessageText, 1, CPos1)
    IF CPos2
      ControlNo = CREATE(ControlNo+1, CREATE:String)
      IF MessageText[CPos2-1] = '<13>'
        ControlNo{PROP:Text} = MessageText[CPos1 : CPos2-2]
      ELSE
        ControlNo{PROP:Text} = MessageText[CPos1 : CPos2-1]
      END
      Width1 = ControlNo{PROP:Width}
      IF Width1 > Width2 THEN Width2 = Width1.
    ELSIF LEN(MessageText) => CPos1
      ControlNo = CREATE(ControlNo+1, CREATE:String)
      ControlNo{PROP:Text} = MessageText[CPos1 : LEN(MessageText)]
      Width1 = ControlNo{PROP:Width}
      IF Width1 > Width2 THEN Width2 = Width1.
    END
    CPos1 = CPos2 + 1
    IF ~CPos2 THEN BREAK.
  END !LOOP

  MsgWin{PROP:Text} = Caption

  IF DisplayIcon
    IconOffset = _IconSize + 2
  ELSE
    IconOffset = 0
  END

  IF (Width2 + 10) > MsgWin{PROP:Width}
    MsgWin{PROP:Width} = Width2 + 10 + IconOffset
  END

  LOOP ControlNo = 1 TO LASTFIELD()
    IF ControlNo = 1 THEN StrHeight = ControlNo{PROP:Height}.
    ControlNo{PROP:XPos} = 4 + IconOffset
    ControlNo{PROP:YPos} = 2+(ControlNo-1)*StrHeight
    ControlNo{PROP:Hide} = 0
  END
  TotalStrings = ControlNo

  IF DisplayIcon
    ControlNo = CREATE(ControlNo+1, CREATE:Image)
    ControlNo{PROP:XPos}   = 4
    ControlNo{PROP:YPos}   = 2
    ControlNo{PROP:Width}  = _IconSize
    ControlNo{PROP:Height} = _IconSize
    ControlNo{PROP:Text}   = DisplayIcon
    ControlNo{PROP:Hide}   = 0
  END

  ButtonCount = 0
  ButtonsVal  = Buttons
  IF ButtonsVal
    TotalButtons = 0
    IF BAND(ButtonsVal, BUTTON:OK    ) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:YES   ) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:NO    ) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:ABORT ) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:RETRY ) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:IGNORE) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:CANCEL) THEN TotalButtons += 1.
    IF BAND(ButtonsVal, BUTTON:HELP  ) THEN TotalButtons += 1.
  ELSE
    ButtonsVal   = BUTTON:OK
    TotalButtons = 1
  END

  !determine minimum window width to handle buttons
  Width2 = (TotalButtons * _ButtonWidth) + |    !width of buttons
           ((TotalButtons + 1) * _ButtonOffset) !spacing between and around them

  !make sure window is wide enough for buttons
  IF Width2 > MsgWin{PROP:Width}
    MsgWin{PROP:Width} = Width2
  END

  !determine width from start of first to end of last button
  Width2 = (TotalButtons * _ButtonWidth) + |    !width of buttons
           ((TotalButtons - 1) * _ButtonOffset) !spacing between and around them
  ButtonX = (MsgWin{PROP:Width} - Width2) / 2

  IF BAND(ButtonsVal, BUTTON:OK)
    ButtonType = BUTTON:OK
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:YES)
    ButtonType = BUTTON:YES
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:NO)
    ButtonType = BUTTON:NO
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:ABORT)
    ButtonType = BUTTON:ABORT
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:RETRY)
    ButtonType = BUTTON:RETRY
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:IGNORE)
    ButtonType = BUTTON:IGNORE
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:CANCEL)
    ButtonType = BUTTON:CANCEL
    DO AddButton
  END
  IF BAND(ButtonsVal, BUTTON:HELP)
    ButtonType = BUTTON:HELP
    DO AddButton
  END

  MsgWin{PROP:Height} = ControlNo{PROP:YPos} + ControlNo{PROP:Height} + 6
  MsgWin{PROP:Center}    = 1

  IF Style THEN MsgWin{PROP:Modal} = 1.  !since property is read-only, this doesn't work

  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF UpKey
      OROF LeftKey
        SELECT(?-1)
      OF DownKey
      OROF RightKey
        SELECT(?+1)
      END
    OF EVENT:Accepted
      !the value inside the brackets is the button count from left;
      !the result is stored in that array element
      Result = ButtonResults[FIELD() - LASTFIELD() + TotalButtons]
      BREAK
    END !CASE
  END !ACCEPT
  CLOSE(MsgWin)
  RETURN(Result)


AddButton ROUTINE

  ButtonCount += 1
  ButtonResults[ButtonCount] = ButtonType
  ControlNo = CREATE(ControlNo+1, CREATE:Button)

  CASE ButtonType
  OF BUTTON:OK
    ControlNo{PROP:Text}   = 'OK'
  OF BUTTON:YES
    ControlNo{PROP:Text}   = '&Yes'
  OF BUTTON:NO
    ControlNo{PROP:Text}   = '&No'
  OF BUTTON:ABORT
    ControlNo{PROP:Text}   = '&Abort'
  OF BUTTON:RETRY
    ControlNo{PROP:Text}   = '&Retry'
  OF BUTTON:IGNORE
    ControlNo{PROP:Text}   = '&Ignore'
  OF BUTTON:CANCEL
    ControlNo{PROP:Text}   = 'Cancel'
  OF BUTTON:HELP
    ControlNo{PROP:Text}   = '&Help'
  END

  ControlNo{PROP:Width}  = _ButtonWidth
  ControlNo{PROP:Height} = _ButtonHeight

  ControlNo{PROP:XPos}   = ButtonX          !set position
  ButtonX += (_ButtonWidth + _ButtonOffset) !and set next buttons position

  ControlNo{PROP:YPos}   = ((TotalStrings-1)*StrHeight) + 6
  IF DisplayIcon AND (ControlNo{PROP:YPos} < _IconSize + 6)
    ControlNo{PROP:YPos}   = _IconSize + 6
  END
  IF ButtonCount > 1
    ControlNo{PROP:Alrt,1} = LeftKey
    ControlNo{PROP:Alrt,2} = UpKey
    IF ButtonCount < TotalButtons
      ControlNo{PROP:Alrt,3} = RightKey
      ControlNo{PROP:Alrt,4} = DownKey
    END
  ELSIF TotalButtons > 1
    ControlNo{PROP:Alrt,1} = RightKey
    ControlNo{PROP:Alrt,2} = DownKey
  END

  IF (DefaultButton = ButtonType) OR (~DefaultButton AND ButtonCount = 1)
    Result = ButtonType
    SELECT(ControlNo)
  END

  ControlNo{PROP:Hide}   = 0

